#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <cstdio>
using namespace std;

#define TASK "player"

typedef long long ll;

struct Segment {
    ll l, r, sm;
    int f, length;
    Segment() {}
    Segment(ll l, ll r, int f):l(l), r(r), f(f), length(r - l), sm(1LL * (r - l) * f) {}

    bool operator < (const Segment & other) const {
        return f > other.f || f == other.f && l < other.l;
    }

    bool operator == (const Segment & other) const {
        return f == other.f && l == other.l && r == other.r;
    }

    int len() const {
        return length;
    }

    ll sum() const {
        return sm;
    }
};


void relax(double& ans, int acel, ll sumT, ll sumF, ll f, const Segment& next) {
    if (f - sumF <= next.sum())
        ans = min(ans, 1.0 * (next.l - sumT) / acel + sumT + 1.0 * max(0LL, f - sumF) / next.f);
}

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, v, ff;
    scanf("%d%d%d", &n, &v, &ff);
    ll f = ff;

    vector<Segment> a;
    ll sumT = 0;
    int smK = 0;
    for (int i = 0; i < n; ++i) {
        int t, k;
        scanf("%d%d", &t, &k);
        smK += k;
        for (int j = 0; j < k; ++j) {
            int l, r, fij;
            scanf("%d%d%d", &l, &r, &fij);
            a.push_back(Segment(l + sumT, r + sumT, fij));
        }
        sumT += t;
    }
    assert(n <= 1000);
    assert(smK <= 1000);
    ll curSum = 0;
    double ans = 1e16;
    vector<Segment> b;
    for (int i = 0; i < a.size(); ++i) {
        curSum += a[i].sum();
        if (curSum < f)
            continue;
        ll sumT = 0, sumFun = 0;
        for (int j = 0; j < b.size(); ++j) {
            relax(ans, v, sumT, sumFun, f, a[i]);
            sumT += b[j].len();
            sumFun += b[j].sum();
        }
        relax(ans, v, sumT, sumFun, f, a[i]);
        b.push_back(a[i]);
        sort(b.begin(), b.end());
        sumT = 0;
        sumFun = 0;
        for (int j = 0; j < b.size(); ++j)
            if (sumFun + b[j].sum() >= f) {
                double add = 1.0 * (f - sumFun) / b[j].f;
                cerr << "lil = " << (a[i].r - sumT - add) / v + sumT + add << endl;
                ans = min(ans, (a[i].r - sumT - add) / v + sumT + add);
                break;
            } else {
                sumFun += b[j].sum();
                sumT += b[j].len();
            }
    }
    if (ans > 1e15)
        printf("-1");
    else
        printf("%.10f", ans);
    return 0;
}