import java.io.*;
import java.util.StringTokenizer;

public class registers_ip {
    public static final int LOG_N = 18;
    public static final String TASK = "registers";

    FastScanner in;
    PrintWriter out;

    Pair get(int bit1, int bit2) {
        return new Pair((bit1 + bit2)>>1, (bit1 + bit2 + 1)>>1);
    }

    public void solve() throws IOException {
        int n = in.nextInt();
        int k = in.nextInt();
        int[] a = new int[n], b = new int[n];
        String as = in.next();
        String bs = in.next();
        Pair[] arr = new Pair[n];
        for (int i = 0; i < n; ++i) {
            a[n - i - 1] = as.charAt(i) - '0';
            b[n - i - 1] = bs.charAt(i) - '0';
        }
        for (int i = 0; i < n; ++i)
            arr[i] = get(a[i], b[i]);

        int[] p = new int[LOG_N];
        for (int i = 0; i < k; ++i) {
            int h = in.nextInt();
            int cs = in.nextInt();
            p[h] = cs;
        }

        int m = in.nextInt();
        SegTree t = new SegTree(n, arr);
        for (int i = 0; i < m; ++i) {
            int num = in.nextInt();
            int bit = in.nextInt();
            if (num == 1) a[bit] ^= 1;
            else b[bit] ^= 1;
            t.update(1, bit + t.size, get(a[bit], b[bit]));
            int ans = Integer.MAX_VALUE;
            for (int bt = 0; bt < LOG_N; ++bt)
                if (p[bt] != 0)
                    ans = Math.min(ans, t.cnt[0][bt][1] * p[bt]);
            out.println(ans);
        }
    }

    class SegTree {
        int[][][] t, cnt;
        int size = 1;
        int[] l, r, log;

        SegTree(int n, Pair[] a) {
            while (size < n + 1) size *= 2;
            cnt = new int[2][LOG_N][2 * size];
            t = new int[2][LOG_N][2 * size];
            l = new int[2 * size];
            r = new int[2 * size];
            log = new int[2 * size];

            build(1, size, 2 * size - 1);
            for (int i = size; i < size + a.length; ++i) {
                t[0][0][i] = a[i - size].t0;
                t[1][0][i] = a[i - size].t1;
            }
            for (int i = size - 1; i >= 1; --i)
                mix(i);
        }

        private void build(int v, int l, int r) {
            this.l[v] = l;
            this.r[v] = r;
            if (l == r)
                return;
            int m = (l + r) / 2;
            build(2 * v, l, m);
            build(2 * v + 1, m + 1, r);
            log[v] = log[2 * v] + 1;
        }

        private void mix(int v) {
            for (int i = 0; i < log[v]; ++i)
                for (int j = 0; j < 2; ++j) {
                    cnt[j][i][v] = cnt[j][i][2 * v] + cnt[t[j][i][2 * v]][i][2 * v + 1] + t[j][i][2 * v];
                    t[j][i][v] = t[t[j][i][2 * v]][i][2 * v + 1];
                }
            t[0][log[v]][v] = t[t[0][log[v] - 1][2 * v]][log[v] - 1][2 * v + 1];
            t[1][log[v]][v] = t[t[1][log[v] - 1][2 * v]][log[v] - 1][2 * v + 1];
        }

        void update(int v, int pos, Pair value) {
            if (log[v] == 0) {
                t[0][0][pos] = value.t0;
                t[1][0][pos] = value.t1;
            } else {
                if (pos <= r[2 * v])
                    update(2 * v, pos, value);
                else
                    update(2 * v + 1, pos, value);
                mix(v);
            }
        }

    }

    class Pair {
        int t0, t1;
        Pair(int x, int y) {
            this.t0 = x;
            this.t1 = y;
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK + ".in"));
            out = new PrintWriter(new File(TASK + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new registers_ip().run();
    }
}
